/**
 * The ClipboardFormats class defines constants for the names of the standard data formats used with the Clipboard class.
 * Flash Player 10 only supports TEXT_FORMAT, RICH_TEXT_FORMAT, and HTML_FORMAT.
 * @internal	Clipboard, ClipboardFormats and ClipboardTransferMode were all added to AIR 1.0. These are also being added, with some exceptions listed in this file, to FP10.
 */
export declare class ClipboardFormats extends Object {
    static AIR_PREFIX: string;
    /**
     * Image data (AIR only).
     */
    static BITMAP_FORMAT: string;
    /**
     * An array of files (AIR only).
     */
    static FILE_LIST_FORMAT: string;
    /**
     * File promise list (AIR only).
     */
    static FILE_PROMISE_LIST_FORMAT: string;
    static FLASH_PREFIX: string;
    /**
     * HTML data.
     */
    static HTML_FORMAT: string;
    static REFERENCE_PREFIX: string;
    /**
     * Rich Text Format data.
     */
    static RICH_TEXT_FORMAT: string;
    static SERIALIZATION_PREFIX: string;
    /**
     * String data.
     */
    static TEXT_FORMAT: string;
    /**
     * A URL string (AIR only).
     */
    static URL_FORMAT: string;
}
