import { IAssetAdapter } from "@awayjs/core";
import { Rectangle } from "../geom/Rectangle";
import { Point } from "../geom/Point";
import { Matrix } from "../geom/Matrix";
import { ColorTransform } from "../geom/ColorTransform";
import { BitmapFilter } from "../filters/BitmapFilter";
import { IBitmapDrawable } from "./IBitmapDrawable";
import { SceneImage2D } from "@awayjs/scene";
import { IBitmapDataOwner } from "./IBitmapDataOwner";
export declare class BitmapData implements IBitmapDrawable, IAssetAdapter {
    private _adaptee;
    private _owners;
    compare(other: BitmapData): boolean;
    readonly adaptee: SceneImage2D;
    static loadBitmap(id: string): BitmapData;
    constructor(width: number, height: number, transparent?: boolean, fillColor?: number);
    transparent: boolean;
    width: number;
    height: number;
    clone(): BitmapData;
    readonly rect: Rectangle;
    getPixel(x: number, y: number): number;
    getPixel32(x: number, y: number): number;
    setPixel(x: number, y: number, color: number): void;
    setPixel32(x: number, y: number, color: number): void;
    applyFilter(sourceBitmap: BitmapData, sourceRect: Rectangle, destPoint: Point, filter: BitmapFilter): number;
    colorTransform(rect: Rectangle, colorTransform: ColorTransform): void;
    copyChannel(sourceBitmap: BitmapData, sourceRect: Rectangle, destPoint: Point, sourceChannel: number, destChannel: number): void;
    copyPixels(sourceBitmap: any, sourceRect: Rectangle, destPoint: Point, alphaBitmapData?: BitmapData, alphaPoint?: Point, mergeAlpha?: boolean): void;
    dispose(): void;
    draw(source: any, matrix: Matrix, colorTransform?: ColorTransform, blendMode?: any, clipRect?: Rectangle, smooth?: boolean): void;
    fillRect(rect: Rectangle, color: number): void;
    floodFill(x: number, y: number, color: number): void;
    generateFilterRect(sourceRect: Rectangle, filter: BitmapFilter): Rectangle;
    getColorBoundsRect(mask: number, color: number, findColor: boolean): Rectangle;
    hitTest(firstPoint: Point, firstAlphaThreshold: number, secondObject: any, secondBitmapPoint?: Point, secondAlphaThreshold?: number): boolean;
    lock(): void;
    merge(sourceBitmap: BitmapData, sourceRect: Rectangle, destPoint: Point, redMult: number, greenMult: number, blueMult: number, alphaMult: number): void;
    noise(randomSeed: number, low: number, high: number, channelOptions: number, grayScale: boolean): void;
    paletteMap(sourceBitmap: BitmapData, sourceRect: Rectangle, destPoint: Point, redArray: any[], greenArray: any[], blueArray: any[], alphaArray: any[]): void;
    perlinNoise(baseX: number, baseY: number, numOctaves: number, randomSeed: number, stitch: boolean, fractalNoise: boolean, channelOptions: number, grayScale: boolean, offsets: any): void;
    pixelDissolve(sourceBitmap: BitmapData, sourceRect: Rectangle, destPoint: Point, randomSeed: number, numberOfPixels: number, fillColor: number): number;
    scroll(x: number, y: number): void;
    threshold(sourceBitmap: BitmapData, sourceRect: Rectangle, destPoint: Point, operation: string, threshold: number, color: number, mask: number, copySource: boolean): number;
    unlock(): void;
    _addOwner(owner: IBitmapDataOwner): void;
    _removeOwner(owner: IBitmapDataOwner): void;
}
