import { EventDispatcher as AwayEventDispatcher, EventBase } from "@awayjs/core";
/**
     * [broadcast event] Dispatched when the Flash Player or AIR application operating
     * loses system focus and is becoming inactive.
     * @eventType	flash.events.Event.DEACTIVATE
    [Event(name="deactivate", type="flash.events.Event")]

     * [broadcast event] Dispatched when the Flash Player or AIR application gains
     * operating system focus and becomes active.
     * @eventType	flash.events.Event.ACTIVATE
    [Event(name="activate", type="flash.events.Event")]
 */
export declare class EventDispatcher extends AwayEventDispatcher {
    static axClass: any;
    axClass: any;
    _symbol: any;
    protected eventMapping: Object;
    protected eventMappingDummys: Object;
    protected eventMappingExtern: Object;
    protected eventMappingInvert: Object;
    _avm1Context: any;
    constructor(target?: any);
    private initActivateListener(type, callback);
    private removeActivateListener(type, callback);
    private _activateCallbackDelegate;
    private activateCallback(event?);
    private initDeactivateListener(type, callback);
    private removeDeactivateListener(type, callback);
    private _deactivateCallbackDelegate;
    private deactivateCallback(event?);
    addEventListener(type: string, listener: (event: EventBase) => void, useCapture?: boolean, priority?: number, useWeakReference?: boolean): void;
    /**
     * Remove an event listener
     * @method removeEventListener
     * @param {String} type of event to remove a listener for
     * @param {Function} listener function
     */
    removeEventListener(type: string, listener: (event: EventBase) => void): void;
}
