/**
 * The SoundTransform class contains properties for volume and panning.
 *
 */
export declare class SoundTransform {
    axCallPublicProperty(value1: any, value2: any): any;
    axGetPublicProperty(value: any): any;
    axSetPublicProperty(value: any, value2: any): any;
    axHasPublicProperty(value: any): any;
    axDeletePublicProperty(value: any): any;
    axGetEnumerableKeys(): string[];
    private _vol;
    private _pan;
    /**
     * Creates a SoundTransform object.
     * @param	vol	The volume, ranging from 0 (silent) to 1 (full volume).
     * @param	panning	The left-to-right panning of the sound, ranging from -1 (full pan left)
     *   to 1 (full pan right). A value of 0 represents no panning (center).
     * @langversion	3.0
     * @playerversion	Flash 9
     * @playerversion	Lite 4
     * @refpath
     */
    constructor(vol?: number, panning?: number);
    /**
     * A value, from 0 (none) to 1 (all), specifying how much of the left input is played in the
     * left speaker.
     */
    leftToLeft: number;
    /**
     * A value, from 0 (none) to 1 (all), specifying how much of the left input is played in the
     * right speaker.
     */
    leftToRight: number;
    /**
     * The left-to-right panning of the sound, ranging from -1 (full pan left)
     * to 1 (full pan right). A value of 0 represents no panning (balanced center between
     * right and left).
     */
    pan: number;
    /**
     * A value, from 0 (none) to 1 (all), specifying how much of the right input is played in the
     * left speaker.
     */
    rightToLeft: number;
    /**
     * A value, from 0 (none) to 1 (all), specifying how much of the right input is played in the
     * right speaker.
     */
    rightToRight: number;
    /**
     * The volume, ranging from 0 (silent) to 1 (full volume).
     */
    volume: number;
}
