/**
 * The XMLNodeType class contains constants used with
 * <codeph class="+ topic/ph pr-d/codeph ">XMLNode.nodeType</codeph>. The values are defined
 * by the NodeType enumeration in the
 * W3C DOM Level 1 recommendation:
 * <xref href="http://www.w3.org/TR/1998/REC-DOM-Level-1-19981001/level-one-core.html" scope="external" class="- topic/xref ">http://www.w3.org/TR/1998/REC-DOM-Level-1-19981001/level-one-core.html</xref>
 * @langversion	3.0
 * @playerversion	Flash 9
 * @playerversion	Lite 4
 */
export declare class XMLNodeType {
    static CDATA_NODE: number;
    static COMMENT_NODE: number;
    static DOCUMENT_TYPE_NODE: number;
    /**
     * Specifies that the node is an element.
     * This constant is used with XMLNode.nodeType.
     * The value is defined by the NodeType enumeration in the
     * W3C DOM Level 1 recommendation:
     * http://www.w3.org/TR/1998/REC-DOM-Level-1-19981001/level-one-core.html
     * @langversion	3.0
     * @playerversion	Flash 9
     * @playerversion	Lite 4
     */
    static ELEMENT_NODE: number;
    static PROCESSING_INSTRUCTION_NODE: number;
    /**
     * Specifies that the node is a text node.
     * This constant is used with XMLNode.nodeType.
     * The value is defined by the NodeType enumeration in the
     * W3C DOM Level 1 recommendation:
     * http://www.w3.org/TR/1998/REC-DOM-Level-1-19981001/level-one-core.html
     * @langversion	3.0
     * @playerversion	Flash 9
     * @playerversion	Lite 4
     */
    static TEXT_NODE: number;
    static XML_DECLARATION: number;
    constructor();
}
