
export {Clipboard} from "./lib/desktop/Clipboard";
export {ClipboardFormats} from "./lib/desktop/ClipboardFormats";

export {Bitmap} from "./lib/display/Bitmap";
export {BitmapData} from "./lib/display/BitmapData";
export {BitmapDataChannel} from "./lib/display/BitmapDataChannel";
export {BlendMode} from "./lib/display/BlendMode";
export {CapsStyle} from "./lib/display/CapsStyle";
export {DisplayObject} from "./lib/display/DisplayObject";
export {DisplayObjectContainer} from "./lib/display/DisplayObjectContainer";
export {GradientType} from "./lib/display/GradientType";
export {Graphics} from "./lib/display/Graphics";
export {GraphicsPath} from "./lib/display/GraphicsPath";
export {GraphicsPathCommand} from "./lib/display/GraphicsPathCommand";
export {GraphicsPathWinding} from "./lib/display/GraphicsPathWinding";
export {IBitmapDataOwner} from "./lib/display/IBitmapDataOwner";
export {IBitmapDrawable} from "./lib/display/IBitmapDrawable";
export {IGraphicsData} from "./lib/display/IGraphicsData";
export {InteractiveObject} from "./lib/display/InteractiveObject";
export {InterpolationMethod} from "./lib/display/InterpolationMethod";
export {JointStyle} from "./lib/display/JointStyle";
export {LineScaleMode} from "./lib/display/LineScaleMode";
export {Loader} from "./lib/display/Loader";
export {LoaderInfo} from "./lib/display/LoaderInfo";
export {MovieClip} from "./lib/display/MovieClip";
export {PixelSnapping} from "./lib/display/PixelSnapping";
export {Shape} from "./lib/display/Shape";
export {SimpleButton} from "./lib/display/SimpleButton";
export {SpreadMethod} from "./lib/display/SpreadMethod";
export {Sprite} from "./lib/display/Sprite";
export {Stage} from "./lib/display/Stage";
export {StageAlign} from "./lib/display/StageAlign";
export {StageScaleMode} from "./lib/display/StageScaleMode";
export {TriangleCulling} from "./lib/display/TriangleCulling";

export {Context3D} from "./lib/display3D/Context3D";
export {Context3DClearMask} from "./lib/display3D/Context3DClearMask";
export {Context3DProgramType} from "./lib/display3D/Context3DProgramType";
export {Texture} from "./lib/display3D/Texture";

export {ErrorEvent} from "./lib/events/ErrorEvent";
export {Event} from "./lib/events/Event";
export {EventDispatcher} from "./lib/events/EventDispatcher";
export {FocusEvent} from "./lib/events/FocusEvent";
export {IEventDispatcher} from "./lib/events/IEventDispatcher";
export {IOErrorEvent} from "./lib/events/IOErrorEvent";
export {KeyboardEvent} from "./lib/events/KeyboardEvent";
export {MouseEvent} from "./lib/events/MouseEvent";
export {ProgressEvent} from "./lib/events/ProgressEvent";
export {SampleDataEvent} from "./lib/events/SampleDataEvent";
export {TextEvent} from "./lib/events/TextEvent";
export {TimerEvent} from "./lib/events/TimerEvent";
export {TouchEvent} from "./lib/events/TouchEvent";

export {ExternalInterface} from "./lib/external/ExternalInterface";

export {FlashSceneGraphFactory} from './lib/factories/FlashSceneGraphFactory';

export {BitmapFilter} from "./lib/filters/BitmapFilter";
export {DropShadowFilter} from "./lib/filters/DropShadowFilter";
export {GlowFilter} from "./lib/filters/GlowFilter";
export {GradientBevelFilter} from "./lib/filters/GradientBevelFilter";

export {NumberFormatter} from "./lib/globalization/NumberFormatter";
export {StringTools} from "./lib/globalization/StringTools"

export {ColorTransform} from "./lib/geom/ColorTransform";
export {Matrix} from "./lib/geom/Matrix";
export {Matrix3D} from "./lib/geom/Matrix3D";
export {Orientation3D} from "./lib/geom/Orientation3D";
export {PerspectiveProjection} from "./lib/geom/PerspectiveProjection";
export {Point} from "./lib/geom/Point";
export {Rectangle} from "./lib/geom/Rectangle";
export {Transform} from "./lib/geom/Transform";
export {Utils3D} from "./lib/geom/Utils3D";
export {Vector3D} from "./lib/geom/Vector3D";


export {ID3Info} from "./lib/media/ID3Info";
export {Sound} from "./lib/media/Sound";
export {SoundChannel} from "./lib/media/SoundChannel";
export {SoundLoaderContext} from "./lib/media/SoundLoaderContext";
export {SoundTransform} from "./lib/media/SoundTransform";

export {navigateToURL} from "./lib/net/navigateToURL";

export {FileReference} from "./lib/net/FileReference";
export {URLLoader} from "./lib/net/URLLoader";
export {URLLoaderDataFormat} from "./lib/net/URLLoaderDataFormat";
export {URLRequest} from "./lib/net/URLRequest";
export {URLRequestMethod} from "./lib/net/URLRequestMethod";
export {URLVariables} from "./lib/net/URLVariables";
export {SharedObject} from "./lib/net/SharedObject";

export {NewObjectSample} from "./lib/sampler/NewObjectSample"
export {Sample} from "./lib/sampler/Sample"

export {ApplicationDomain}	from "./lib/system/ApplicationDomain";
export {Capabilities}	from "./lib/system/Capabilities";
export {IME}	from "./lib/system/IME";
export {LoaderContext}	from "./lib/system/LoaderContext";
export {SecurityDomain}	from "./lib/system/SecurityDomain";
export {System}	from "./lib/system/System";

export {AntiAliasType} from "./lib/text/AntiAliasType";
export {Font} from "./lib/text/Font";
export {GridFitType} from "./lib/text/GridFitType";
export {StyleSheet} from "./lib/text/StyleSheet";
export {TextField} from "./lib/text/TextField";
export {TextFieldAutoSize} from "./lib/text/TextFieldAutoSize";
export {TextFieldType} from "./lib/text/TextFieldType";
export {TextFormat} from "./lib/text/TextFormat";
export {TextFormatAlign} from "./lib/text/TextFormatAlign";
export {TextInteractionMode} from "./lib/text/TextInteractionMode";
export {TextLineMetrics} from "./lib/text/TextLineMetrics";

export {Keyboard}	from "./lib/ui/Keyboard";
export {Mouse}	from "./lib/ui/Mouse";
export {Multitouch}	from "./lib/ui/Multitouch";
export {MultitouchInputMode}	from "./lib/ui/MultitouchInputMode";

export {clearInterval} from "./lib/utils/clearInterval";
export {clearTimeout} from "./lib/utils/clearTimeout";
export {describeType} from "./lib/utils/describeType";
export {escapeMultiByte} from "./lib/utils/escapeMultiByte";
export {getAliasName} from "./lib/utils/getAliasName";
export {getDefinitionByName} from "./lib/utils/getDefinitionByName";
export {getQualifiedClassName} from "./lib/utils/getQualifiedClassName";
export {getQualifiedSuperclassName} from "./lib/utils/getQualifiedSuperclassName";
export {getTimer} from "./lib/utils/getTimer";//js (not used / already transpiled)
export {setInterval} from "./lib/utils/setInterval";
export {setTimeout} from "./lib/utils/setTimeout";
export {unescapeMultiByte} from "./lib/utils/unescapeMultiByte";

export {AwayDate} from "./lib/utils/AwayDate";
export {ByteArray} from "./lib/utils/ByteArray";//awayjs
export {Dictionary} from "./lib/utils/Dictionary";
export {Endian} from "./lib/utils/Endian";//standalone
export {IDataInput} from "./lib/utils/IDataInput";
export {IDataOutput} from "./lib/utils/IDataOutput";
export {IExternalizable} from "./lib/utils/IExternalizable";
export {Timer} from "./lib/utils/Timer";
export {Trace} from "./lib/utils/Trace";

//Dummy classes:
export {XML}	from "./lib/xml/XML";
export {XMLDocumentAway}	from "./lib/xml/XMLDocumentAway";
export {XMLList}	from "./lib/xml/XMLList";
export {XMLNode}	from "./lib/xml/XMLNode";
export {XMLNodeType}	from "./lib/xml/XMLNodeType";

export * from "./lib/RegisterCode";

// make some extra stuff available from awayjs

export {AssetLibrary} from "@awayjs/core";



/* starling adapter are only temporary here
 totally dummy classes
 */

export { SystemUtil} from './lib/starling/utils/SystemUtil';
//export { Texture} from './lib/starling/textures/Texture';
export { RenderTexture} from './lib/starling/textures/RenderTexture';
//export { TouchPhase} from './lib/starling/events/TouchPhase';
//export { TouchEvent} from './lib/starling/events/TouchEvent';
export { Touch} from './lib/starling/events/Touch';
export { ResizeEvent} from './lib/starling/events/ResizeEvent';
//export { Event} from './lib/starling/events/Event';
//export { Stage} from './lib/starling/display/Stage';
//export { Sprite} from './lib/starling/display/Sprite';
export { Quad} from './lib/starling/display/Quad';
export { Image} from './lib/starling/display/Image';
//export { DisplayObject} from './lib/starling/display/DisplayObject';
export { Starling} from './lib/starling/core/Starling';

